/*
 * statemanager.cpp
 *
 *  Created on: 03-08-2013
 *      Author: crm
 */

#include "gameengine.h"

#include "log.h"

#include "sound.h"

#include "base/gamestate.h"
#include "database/controllermanager.h"

namespace GameEngine
	{
	std::vector<GameState *> states;

	bool run;
	}

bool GameEngine::init()
	{
	states.reserve(16u);

	run=true;

	ControllerManager::init("config.nvo");

	return true;
	}

void GameEngine::update(float dt)
	{
	ControllerManager::update(dt);
	Sound::update(dt);
	states.back()->update(dt);
	}

void GameEngine::print()
	{
	GameState* gs=states.back();
	gs->print();
	}

void GameEngine::clear()
	{
	while(states.size()>0u)
		{
		states.back()->clear();
		states.pop_back();
		}

	ControllerManager::clear();
	}


/*void GameEngine::setState(GameState *gs)
	{
	//
	}*/

void GameEngine::pushState(GameState *gs)
	{
	GameState *bgs=(states.size()>0)?states.back():NULL;

	states.push_back(gs);

	//Log::info("GameEngine.pushState: %u on stack", states.size());

	if(states.size()>1)
		bgs->pause();
	gs->init();
	}

void GameEngine::popState()
	{
	const unsigned SIZE=states.size();

	if(SIZE==0u)
		return;
	if(SIZE==1u)
		{
		GameEngine::stop();	// clear ostatniego state bedzie zrobiony w clear gameengine
		return;
		}
	else
		states[states.size()-2u]->resume();
	states.back()->clear();
	delete states.back();
	states.pop_back();

	//Log::info("GameEngine.popState: %u on stack", states.size());
	}

GameState* GameEngine::getState() {return states.back();}

void GameEngine::stop() {run=false;}
bool GameEngine::isRunning()  {return run;}
