/*
 * combo.h
 *
 *  Created on: 23-08-2013
 *      Author: crm
 */

#pragma once

#include <list>
#include <vector>
#include <cstddef> // NULL

#include "base/event.h"
#include "base/eventlistener.h"

class ComboManager: public EventListener
	{
	public:
		class Combo
			{
			private:
				int ref;
				std::vector<int> combo;

			public:
				 Combo(): ref(0) {}
				 Combo(const Combo& c): ref(c.ref) {combo=c.combo;}
				~Combo() {clear();}

				inline void clear() {combo.clear();}

				inline bool hasMatch(const std::list<Event>& events);
				inline void addEvent(int e) {combo.push_back(e);}

				inline void setRef(int r) {ref=r;}
				inline int getRef() const {return ref;}
			};

	private:
		int update();

		bool need_update;

		std::vector<Combo> combos;
		//Combo *match;

	public:
		ComboManager(): need_update(false)/*, match(NULL)*/ {}
		virtual ~ComboManager() {clear();}

		//void update() {update(events);}
		//void update();
		//void update(const std::list<Event>& events);
		void clear() {combos.clear(); /*match=NULL;*/ EventListener::clear();}

		void pushEvent(const Event& e);// {need_update=true; EventListener::pushEvent(e);}	// z EventListenera
		void clearEvents() {EventListener::clear();}
		void addCombo(const Combo& c) {combos.push_back(c); need_update=true;}

		int hasMatch() {return update();}
		//int getRef() const {return (!match)?0:match->getRef();}
	};
