/*
 * client_send.cpp
 *
 *  Created on: 05-12-2013
 *      Author: crm
 */

#include "client.h"

#include "resfile.h"
#include "log.h"

#include "../packet_dialogi.h"
#include "database/characterdb.h"
#include "gameplay/character.h"

using namespace Network;

void Client::sendWelcome()
	{
	Welcome w;

	w.pid=self.pid;

	send(WELCOME, sizeof(w), (char*)&w);
	}

void Client::sendInfoCharacter()
	{
	const CharacterDatabase::Entry *cdb;
	cdb=CharacterDatabase::getByPath(self.character->getPath());

	if(!cdb)
		{
		Log::fail("Client.sendInfoCharacter: Nie znaleziono informacji o postaci \"%s\" w db", self.character->getPath().c_str());
		disconnect();
		return;
		}

	InfoCharacter ci;

	ci.cid=-1;
	ci.crc=cdb->crc;

	send(INFO_CHARACTER, sizeof(ci), (char*)&ci);
	}

void Client::sendInfoCharacter(int cid)
	{
	InfoCharacter ci;

	ci.cid=cid;
	ci.crc=0;

	send(INFO_CHARACTER, sizeof(ci), (char*)&ci);
	}

void Client::sendEventController()
	{
	ControllerState cs;

	cs.keys=ctrlState;

	client.send(EVENT_CONTROLLER, sizeof(cs), (char *)&cs);
	}

void Client::sendRequestCharacter(unsigned crc)
	{
	transfer.download(Request::CHARACTER, crc);
	}

void Client::sendRequestArena(unsigned crc)
	{
	transfer.download(Request::ARENA, crc);
	}

