/*
 * server.h
 *
 *  Created on: 17-08-2013
 *      Author: crm
 */

#pragma once

extern "C"
	{
	#include <SDL/SDL_net.h>
	#include <SDL/SDL_thread.h>
	}

#include <list>
#include <vector>

#include "packet.h"
#include "sockclient.h"
#include "base/eventprovider.h"

namespace Network
	{
	class SocketServer: public EventProvider
		{
		private:
			//IPaddress ip;
			TCPsocket server;
			SDLNet_SocketSet sset;
			std::vector<SocketClient *> clients;

			int nextid;
			unsigned send_sum;
			unsigned read_sum;

			static int run(void *data);		// data -> SocketServer*

			//void update();
			void updateJoin();
			void updateClients();

		public:
			SocketServer(): server(NULL), sset(NULL), /*client_count(0),*/ nextid(0), send_sum(0), read_sum(0) {}
			~SocketServer() {clear();}

			bool init(int port, int maxclients);
			void update();
			void clear();

			void disconnect(int id);
			void send(int id, int type, int length, const char *data);

			bool isListening() const {return server!=NULL;}
			int getClientCount() const {return clients.size();}
			unsigned getSendSum() {unsigned r; r=send_sum; send_sum=0u; return r;}
			unsigned getReadSum() {unsigned r; r=read_sum; read_sum=0u; return r;}

			SocketClient* getClient(int id);

			bool isConnected(int id);
			bool hasPacket(int id);
			unsigned getLag(int id);
			Packet* getPacket(int id);
		};
	}
