/*
 * engine.cpp
 *
 *  Created on: 27-05-2014
 *      Author: crm
 */

#include "engine.h"

#include <SDL/SDL.h>
#include <GL/glee.h>
#include <GL/gl.h>

#include "resource.h"
#include "log.h"

#include "render.h"

namespace Engine
	{
	bool run=false;

	float dt=0.0f;

	unsigned frametime=0u;

	unsigned char *keystate=NULL;

	AVector mousemotion;
	}


bool Engine::init()
	{
	keystate=SDL_GetKeyState(NULL);

	if(SDL_Init(SDL_INIT_VIDEO)<0)
		{
		Log::fail("Render.init: Nie udalo sie zainicjowac SDL'a");
		return false;
		}

	run=true;

	return true;
	}

void Engine::update()
	{
	SDL_Event e;

	while(SDL_PollEvent(&e))
		{
		switch(e.type)
			{
			case SDL_QUIT:
				run=false;
			break;

			case SDL_KEYDOWN:
				if( (e.key.keysym.sym==SDLK_F4 && (e.key.keysym.mod&KMOD_ALT)) ||
					 e.key.keysym.sym==SDLK_ESCAPE)
					run=false;
				if(e.key.keysym.sym==SDLK_RETURN && (e.key.keysym.mod&KMOD_ALT))
					Render::setFullscreen(!Render::getFullscreen());
			break;

			default:
				//
			break;
			}
		}

	//Render::update();

	dt=(SDL_GetTicks()-frametime)*0.001f;

	if(dt<0.001f)
		{
		//dt=0.001f;
		SDL_Delay(1u);
		dt=(SDL_GetTicks()-frametime)*0.001f;
		}
	if(dt>0.1f)
		dt=0.1f;

	frametime=SDL_GetTicks();
	}

void Engine::clear()
	{
	//
	}

bool Engine::running()
	{
	return run;
	}

float Engine::delta()
	{
	return dt;
	}

bool Engine::key(int sym)
	{
	return keystate[sym];
	}


AVector Engine::getMouseMotion()
	{
	return mousemotion;
	}

AVector Engine::getMousePosition()
	{
	int mx, my;
	SDL_GetMouseState(&mx, &my);

	return AVector(mx, my);
	}


