/*
 * imagemanager.h
 *
 *  Created on: 25-02-2013
 *      Author: crm
 */

#pragma once

#include <string>

struct SDL_Surface;

namespace Graphics
	{
	struct Image;

	namespace ImageManager
		{
		enum Type
			{
			IMG_32_RGBA,	// Domyslne
			IMG_32_ABGR,	// Wsteczne RGBA
			IMG_32_BGRA,	// Windowsowe 32 bity?						// A jednak nie.
			IMG_32_ARGB,	// Gdzies toto w ogole jest uzywane? o;		// A jednak tak.
			IMG_24_RGB,		// Chyba najprostsza sytuacja o;
			IMG_24_BGR,		// No, jeszcze kolejnosc wsteczna
			IMG_16_RGB_555,	// Nie zrobione~							// Juz zrobione~
			IMG_16_RGB_655,	// Windowsowe 16 bitow?
			IMG_16_RGB_565,	// Nie zrobione~							// Juz zrobione~
			IMG_16_RGB_556,	// Nie zrobione~							// Juz zrobione~
			IMG_8,			// Nope, to nie jest paletowe - skala odcieni szarosci

			IMG_32_WINDOWS=	IMG_32_ARGB,
			IMG_24_WINDOWS=	IMG_24_RGB,
			IMG_16_WINDOWS=	IMG_16_RGB_565,
			IMG_8_WINDOWS=	IMG_8,
			};

		void reload();		// Przeladowanie tekstur z sdlsurfa
		void flush();		// Wywalenie nieuzywanych obrazkow
		void clear();		// Sprzatniecie wszystkiego

		const Image* get(const std::string& name);													// Nazwa obrazka do wczytania z dysku/resfile
		const Image* get(const std::string& name, SDL_Surface *srf);								// Wczytanie obrazka z pamieci, tak jak i ponizsza metoda, maja refs'a ustawionego na duza wartosc
		const Image* get(const std::string& name, unsigned char *pixs, int w, int h, Type type);	// Wczytanie obrazka z pamieci, tak dodane maja refs'a ustawianego na DUZA wartosc

		void free(const Image* img);
		}
	}
