/*
 * sprite.cpp
 *
 *  Created on: 22-02-2013
 *      Author: crm
 */

#include "sprite.h"
#include "imagemanager.h"
#include "image.h"

//#include "log.h"

namespace Graphics
	{
	Direction::Direction(): speed(0.0f), ret(0u)
		{
		//
		}

	Direction::~Direction()
		{
		clear();
		}


	void Direction::clear()
		{
		frames.clear();
		}
	}

namespace Graphics
	{
	Animation::Animation(bool noinit)
		{
		for(unsigned i=0u; i<COUNT; ++i)
			dirs[i]=NULL;

		if(!noinit)
			init();
		}

	Animation::~Animation()
		{
		clear();

		delete dirs[DEFAULT];
		}


	void Animation::init()
		{
		/*if(dirs[DEFAULT])
			return;

		dirs[DEFAULT]=new Direction();		// Tego akutrat nie ma sensu zabezpieczac - jak nie zrobi to i tak sie wszystko wysypie

		for(unsigned i=0u; i<COUNT; ++i)
			dirs[i]=dirs[DEFAULT];

		dirs[DEFAULT]->setSpeed(0.0f);
		dirs[DEFAULT]->setReturn(0);*/

		for(unsigned i=0u; i<COUNT; ++i)
			dirs[i]=NULL;
		}

	void Animation::clear()
		{
		for(unsigned i=0u; i<COUNT; ++i)
			{
			if(!dirs[i])
				continue;

			delete dirs[i];

			for(unsigned j=i+1u; j<COUNT; ++j)	// Zerowanie zdublowanych wskaznikow
				if(dirs[i]==dirs[j])
					dirs[j]=NULL;

			dirs[i]=NULL;
			}

		init();
		}


	void Animation::addDirection(Directions dir, Direction *pdir)
		{
		// Jesli nie ma zadnych kierunkow, ustaw wszystkie na domyslny
		if(dirs[DEFAULT]==NULL)
			{
			for(unsigned i=0u; i<COUNT; ++i)
				dirs[i]=pdir;
			return;
			}

		// Nadpisywanie defaulta
		/*if(dir==DEFAULT)
			{
			const Direction *d=dirs[DEFAULT];

			for(unsigned i=0u; i<COUNT; ++i)
				if(dirs[i]==d);
					dirs[i]=pdir;
			}*/

		// Nadpisywanie kierunku - nope (wskazniki spriteptr'a sie wysypia)
		//if(dirs[dir]!=dirs[DEFAULT])
		//	return;

		dirs[dir]=pdir;
		//if(dir+1<COUNT && dirs[dir+1]==dirs[DEFAULT])
		//	dirs[dir+1]=pdir;
		}
	}

namespace Graphics
	{
	Sprite::Sprite(const std::string& path): img(NULL), name(path)
		{
		//
		}

	Sprite::~Sprite()
		{
		//Log::debug("~Sprite");
		clear();
		}

	void Sprite::clear()
		{
		setImage(NULL);

		for(unsigned i=0; i<anims.size(); ++i)
			delete anims[i];

		anims.clear();
		named.clear();
		}


	unsigned Sprite::getAnimID(const Animation *a) const
		{
		for(unsigned i=0u; i<anims.size(); ++i)
			if(anims[i]==a)
				return i;

		return 0u;
		}

	unsigned Sprite::getAnimID(const std::string& name) const
		{
		return getAnimID( &getAnim(name) );
		}


	void Sprite::setImage(const Image *simg)
		{
		if(img)
			{
			img->unref();
			if(img->refs()<=0)
				ImageManager::free(img);
			}

		img=simg;

		if(img)
			img->ref();
		}

	/*unsigned Sprite::addAnimation()
		{
		anims.push_back( new Animation() );		// Tak jak z kierunkami, jak nie zrobi animacji to wsio sie posypie

		return anims.size()-1;
		}

	unsigned Sprite::addAnimation(const std::string name)
		{
		unsigned a;

		a=addAnimation();
		named[name]=anims[a];

		return a;
		}

	void Sprite::addFrame(unsigned anim, Directions dir, const Frame& f)
		{
		anims[anim]->addFrame(dir, f);
		}*/

	void Sprite::setAnimation(unsigned i, Animation *ani, const std::string& name)
		{
		if(i>=anims.size())
			anims.push_back(ani);
		else
			{
			if(anims[i])
				delete anims[i];

			anims[i]=ani;
			}

		if(name.length()>1)
			named[name]=ani;
		}
	}
