/*
 * sound2.cpp
 *
 *  Created on: 23-07-2013
 *      Author: crm
 */

#include "sound.h"

#include <map>
#include <vector>
#include <assert.h>

#include <SDL/SDL_mixer.h>

#include "log.h"
#include "resource.h"

#ifdef WIN32
	#define WINDOWS
#else
	#define LINUX
#endif

/******************************************************************************/
/****************** Zmienne ***************************************************/
/******************************************************************************/
namespace Sound
	{
	struct Sound
		{
		Sound(): name(""), snd(NULL), data(NULL), size(0u) {}
		Sound(const Sound& s): name(s.name), snd(s.snd), data(s.data), size(s.size) {}
		~Sound() {if(data) delete [] data; if(snd) Mix_FreeChunk(snd);}

		std::string name;

		//audiere::SampleSourcePtr snd;
		Mix_Chunk *snd;

		char *data;
		unsigned size;
		};

	/*struct Stream
		{
		Stream(): strm(NULL), vol(1.0f), pitch(1.0f), pan(0.0f) {}
		Stream(const Stream& s): strm(s.strm), vol(s.vol), pitch(s.pitch), pan(s.pan) {}

		//audiere::OutputStreamPtr strm;

		float vol, pitch, pan;
		};*/

	//audiere::AudioDevicePtr dev;

	//std::map<std::string, int> names;
	std::vector<Sound *> sounds;
	//std::vector<Stream> streams;

	float volsnd=1.0f;
	float volmus=1.0f;
	}

/******************************************************************************/
/***************** Funkcje ****************************************************/
/******************************************************************************/
namespace Sound
	{
	//int findFreeChannel(int begin);

	Sound* findSoundByName(const std::string& name);
	Sound* load(const std::string& name);

	//Sound* loadRaw(const std::string& name);
	//Sound* loadRes(const std::string& name);
	}

namespace Sound
	{
	bool init(int channels)
		{
#ifdef WINDOWS
		if(!(Mix_Init(MIX_INIT_OGG)&MIX_INIT_OGG))
			{
			Log::fail("Sound.init: Nie udalo sie uruchomic dekodera ogg");
			return false;
			}
#endif

		if(Mix_OpenAudio(44100, MIX_DEFAULT_FORMAT, 2, 2048)<0)
			{
			Log::fail("Sound.init: Nie udalo sie uruchomic dzwieku");
			return false;
			}

		if(Mix_AllocateChannels(channels)<channels)
			{
			Log::fail("Sound.init: Nie udalo sie zaalokowac kanalow (%d)", channels);
			return false;
			}

		/*{
			int n;
			n=Mix_GetNumChunkDecoders();
			Log::info("Sound.init: chunk decoder count: %d", n);
			for(int i=0; i<n; ++i)
				Log::info(" > %s", Mix_GetChunkDecoder(i));

			n=Mix_GetNumMusicDecoders();
			Log::info("Sound.init: music decoder count: %d", n);
			for(int i=0; i<n; ++i)
				Log::info(" > %s", Mix_GetChunkDecoder(i));
		}*/

		//streams.resize(channels);

		return true;
		}

	void update(float /*dt*/)
		{
		/*for(std::vector<Stream>::iterator it=streams.begin(); it!=streams.end(); ++it)
			{
			Stream& s=*it;

			if(s.strm.get()==NULL || !s.strm->isPlaying())
				continue;

			float vol, pch, pan;

			vol=s.strm->getVolume();
			pch=s.strm->getPitchShift();
			pan=s.strm->getPan();
			}*/
		}

	void clear()
		{
		//Log::info("Sound.clear: Czyszczenie, %u dzwiekow, %u kanalow, %u nazw", sounds.size(), streams.size(), names.size());

		//dev=NULL;

		//names.clear();

		for(std::vector<Sound *>::iterator it=sounds.begin(); it!=sounds.end(); ++it)
			delete *it;

		//for(std::vector<Stream>::iterator it=streams.begin(); it!=streams.end(); ++it)
		//	;//it->strm=NULL;

		sounds.clear();
		//streams.clear();

#ifdef WINDOWS
		Mix_Quit();
#endif

		Log::ok("Sound.clear: Wyczyszczono");
		}
	}

namespace Sound
	{
	int sound(const std::string& name, float volume)
		{
		return play(name, -1, volume*volsnd, false, 0.0f, 1.0f);
		}

	int music(const std::string& name, float volume)
		{
		return play(name, -1, volume*volmus,  true, 0.0f, 1.0f);
		}
	}

namespace Sound
	{
	void pause(int channel)
		{
		//assert(channel>=0 && channel<(int)streams.size());

		//streams[channel].strm->stop();

		Mix_Pause(channel);
		}

	void resume(int channel)
		{
		//assert(channel>=0 && channel<(int)streams.size());

		//streams[channel].strm->play();
		Mix_Resume(channel);
		}

	void stop(int channel)
		{
		//assert(channel>=0 && channel<(int)streams.size());

		//streams[channel].strm->stop();
		//streams[channel].strm->reset();
		//Mix_Pause(channel);
		Mix_HaltChannel(channel);
		}

	void rewind(int channel)
		{
		//assert(channel>=0 && channel<(int)streams.size());

		//streams[channel].strm->reset();
		Mix_HaltChannel(channel);
		Mix_Resume(channel);
		// todo
		}


	bool isPlaying(int channel)
		{
		//assert(channel>=0 && channel<(int)streams.size());

		return Mix_Playing(channel);//streams[channel].strm->isPlaying();
		}


	void setGlobalSoundVolume(float vol)
		{
		volsnd=vol;
		}

	void setGlobalMusicVolume(float vol)
		{
		volmus=vol;
		}


	void setPitch(int channel, float val, int /*timeout*/)
		{
		//assert(channel>=0 && channel<(int)streams.size());

		//streams[channel].pitch=val;

		//streams[channel].strm->setPitchShift(val);
		}

	void setVolume(int channel, float val, int /*timeout*/)
		{
		//assert(channel>=0 && channel<(int)streams.size());

		//streams[channel].vol=val;

		//streams[channel].strm->setVolume(val);
		}

	void setPan(int channel, float val, int /*timeout*/)
		{
		//assert(channel>=0 && channel<(int)streams.size());

		//streams[channel].pan=val;

		//streams[channel].strm->setPan(val);
		}


	float getGlobalSoundVolume()
		{
		return volsnd;
		}

	float getGlobalMusicVolume()
		{
		return volmus;
		}


	float getPitch(int channel)
		{
		//assert(channel>=0 && channel<(int)streams.size());

		return 0;//streams[channel].strm->getPitchShift();
		}

	float getVolume(int channel)
		{
		//assert(channel>=0 && channel<(int)streams.size());

		return 0;//streams[channel].strm->getVolume();
		}

	float getPan(int channel)
		{
		//assert(channel>=0 && channel<(int)streams.size());

		return 0;//streams[channel].strm->getPan();
		}
	}

namespace Sound
	{
	Sound* findSoundByName(const std::string& name)
		{
		for(std::vector<Sound *>::iterator it=sounds.begin(); it!=sounds.end(); ++it)
			{
			if(name.compare((*it)->name)==0)
				return *it;
			}

		return NULL;
		}
	}

namespace Sound
	{
	Sound* load(const std::string& name)
		{
		Sound *snd;

		snd=new Sound();

		snd->data=Resource::load(name);
		snd->size=Resource::getSize();

		if(!snd->data)
			{
			delete snd;

			return NULL;
			}

		snd->snd=Mix_LoadWAV_RW( SDL_RWFromMem(snd->data, snd->size), false);

		sounds.push_back(snd);

		return snd;
		}
	}

namespace Sound
	{
	int play(const std::string& name, int channel, float volume, bool repeat, float pan, float pitch)
		{
		Sound *snd;

		snd=findSoundByName(name);
		if(!snd)
			{
			snd=load(name);

			if(!snd)
				{
				Log::fail("Sound.play: Nie udalo sie wczytac dzwieku \"%s\"", name.c_str());
				return -1;
				}
			}

		const int r=Mix_PlayChannel(channel, snd->snd, (repeat)?-1:0);
		Log::debug("Sound.play: Odtwarzanie \"%s\" na kanale %d; vol %f; repeat: %s; pitch: %f; pan: %f", name.c_str(), r, volume, (repeat)?"TRUE":"FALSE", pitch, pan);

		return r;
		}
	}
