/*
 * sound2.h
 *
 *  Created on: 23-07-2013
 *      Author: crm
 */

#pragma once

#include <string>

namespace Sound
	{
	bool init(int channels);
	void update(float dt);
	void clear();

	int sound(const std::string& name, float volume=1.0f);
	int music(const std::string& name, float volume=1.0f);

	int play(const std::string& name, int channel, float volume, bool repeat, float pan, float pitch);
	void pause(int channel);
	void resume(int channel);
	void stop(int channel);
	void rewind(int channel);

	bool isPlaying(int channel);

	void setGlobalSoundVolume(float vol);	// vol jest znormalizowane (0.0f-1.0f)
	void setGlobalMusicVolume(float vol);	// vol jest znormalizowane (0.0f-1.0f)

	void setPitch(int channel, float val, int timeout=0);
	void setVolume(int channel, float val, int timeout=0);
	void setPan(int channel, float val, int timeout=0);

	float getGlobalSoundVolume();
	float getGlobalMusicVolume();

	float getPitch(int channel);
	float getVolume(int channel);
	float getPan(int channel);

	//int findFreeChannel(int begin=0);

	//int getChannelByName(const std::string& name);
	//bool setChannelName(const std::string& name, int channel);
	}
