/*
 * CounterAnimated.cpp
 *
 *  Created on: 26-03-2013
 *      Author: crm
 */

#include "counteranimated.h"

#include "../graphics/sprite.h"
#include "../render.h"

namespace UI
	{
	CounterAnimated::CounterAnimated(): Counter()
		{
		//
		}


	void CounterAnimated::init(const std::string& name, float min, float max, float val)
		{
		Counter::init(min, max, val);
		spr.setSprite(name);
		}


	void CounterAnimated::update(float dt)
		{
		if(value<min)
			value=min;
		else if(value>max)
			value=max;

		unsigned anim=(value-min)/(max-min)*(spr->getAnims()-1);

		spr.setAnim(anim);
		spr.update(dt);
		}

	void CounterAnimated::print(float x, float y)
		{
		//Render::print(spr, x, y, 0.0f);
		}

	void CounterAnimated::clear()
		{
		spr.clear();
		}
	}
